<template>
  <v-dialog
    v-if="size === 'compact'"
    v-model="dialog"
    :scrim="false"
    :absolute="true"
    class="top-10"
    :close-on-content-click="false"
    :contained="true"
  >
    <template #activator="{ props }">
      <svn-pro-icon-button
        v-bind="props"
        icon="custom:mingcute:paragraph-line"
        variant="text"
        :active="activeItemRef?.id !== 'paragraph'"
        color="onSurfaceVariant"
      />
    </template>

    <template #default>
      <div class="flex flex-col gap-2 py-2 rounded-[4px] w-[200px] min-w-[112px] h-full cardShadow">
        <v-list
          color="primary"
          density="compact"
          class="!py-0"
        >
          <v-list-item
            v-for="element in states(editorRef)?.filter(el => selectionItemsRef?.includes(el.id))"
            :key="`${element?.id}`"
            :value="`${element?.id}`"
            class="w-full"
            @click="element.onClick"
          >
            <svn-pro-text v-if="element.type === 'category'" bodyLarge regular>
              {{ element.title }}
            </svn-pro-text>

            <div v-else class="w-full flex gap-3 items-center">
              <div>
                <Icon :icon="element?.icon" height="16" width="16" />
              </div>

              <svn-pro-text v-if="element.type === 'option'" bodyLarge regular>
                {{ element.title }}
              </svn-pro-text>
            </div>
          </v-list-item>
        </v-list>
      </div>
    </template>
  </v-dialog>

  <Popover v-else class="relative">
    <PopoverButton>
      <svn-pro-icon-button
        icon="custom:mingcute:paragraph-line"
        variant="text"
        :active="activeItemRef?.id !== 'paragraph'"
        color="onSurfaceVariant"
      />
    </PopoverButton>

    <PopoverPanel class="absolute z-10">
      <div class="flex flex-col gap-2 py-2 rounded-[4px] w-[200px] max-h-[496px] min-w-[112px] h-full cardShadow overflow-y-auto">
        <v-list
          color="primary"
          density="compact"
          class="!py-0"
        >
          <v-list-item
            v-for="element in states(editorRef)?.filter(el => selectionItemsRef?.includes(el.id))"
            :key="`${element?.id}`"
            :value="`${element?.id}`"
            class="w-full"
            @click="element.onClick"
          >
            <svn-pro-text v-if="element.type === 'category'" bodyLarge regular>
              {{ element.title }}
            </svn-pro-text>

            <div v-else class="w-full flex gap-3 items-center">
              <div>
                <Icon :icon="element?.icon" height="16" width="16" />
              </div>

              <svn-pro-text v-if="element.type === 'option'" bodyLarge regular>
                {{ element.title }}
              </svn-pro-text>
            </div>
          </v-list-item>
        </v-list>
      </div>
    </PopoverPanel>
  </Popover>
</template>

<script setup>
import { Icon } from '@iconify/vue';
import { Editor } from '@tiptap/vue-3';
import { watch, ref, onMounted } from 'vue';
import SvnProText from '../../styles/SvnProText.vue';
import SvnProIconButton from '../../button/SvnProIconButton.vue';
import { Popover, PopoverButton, PopoverPanel } from '@headlessui/vue';
import { useTextMenuContentTypes as states } from '../hooks/useTextMenuContentTypes.js';

const props = defineProps({
  size: { type: String, default: null },
  editor: { type: Editor, default: null },
  activeItem: { type: Object, default: () => {} },
  selectionItems: { type: Array, default: () => [] },
});

onMounted(() => {
  editorRef.value = props.editor
  activeItemRef.value = props.activeItem
  selectionItemsRef.value = props.selectionItems
});

const dialog = ref(false);
const editorRef = ref(null);
const activeItemRef = ref(null);
const selectionItemsRef = ref([]);

watch(props, (newValue, oldValue) => {
  if (newValue.editor) {
    editorRef.value = props.editor
  }
  if (newValue.activeItem) {
    activeItemRef.value = props.activeItem
  }
  if (newValue.selectionItems) {
    selectionItemsRef.value = props.selectionItems
  }
});
</script>

<style lang="scss">
.cardShadow {
  box-shadow: 0px 8px 10px 0px rgba(0, 0, 0, 0.14), 0px 3px 14px 0px rgba(0, 0, 0, 0.12), 0px 5px 5px 0px rgba(0, 0, 0, 0.20);
}
</style>